;; ========================================================================================================
;; gdm_m1_gewinde.lsp
;; os / 08.05.2006 13:54

(in-package  :GDM)
(use-package :oli)

;; ========================================================================================================
;; Logical Table fuer metrisches Gewinde
(sd-create-logical-table
 "M-Gew-Tab"
  :columns     '(:GEW_NAME      :NENN_D    :KERN_D    :STEIGUNG    :GEW_ART  :GEW_INNEN   :METR   :RECHTS_GEW)
  :columnNames '("Bezeichnung"  "Nenn_D"   "Kern_D"   "Steigung"   "Art"     "Innengew."  "metr." "Rechtsgew.")
  :types       '(:string        :length    :length    :length      nil       nil          nil     nil)
  :units       '(nil            :mm        :mm        :mm          nil       nil          nil     nil)
  :contents   '(
                ("M1"            1         0.73       0.25        :M         t            t       t)
                ("M1,2"          1.2       0.93       0.25        :M         t            t       t)
                ("M1,6"          1.6       1.22       0.35        :M         t            t       t)
                ("M2"            2         1.57       0.4         :M         t            t       t)
                ("M2,5"          2.5       2.01       0.35        :M         t            t       t)
                ("M3"            3         2.46       0.5         :M         t            t       t)
                ("M4"            4         3.24       0.7         :M         t            t       t)
                ("M5"            5         4.13       0.8         :M         t            t       t)
                ("M6"            6         4.92       1           :M         t            t       t)
                ("M8"            8         6.65       1.25        :M         t            t       t)
                ("M10"          10         8.38       1.5         :M         t            t       t)
               )
);;sd-create-logical-table

;; =====================
(sd-create-display-table
     "M-Gew-Tab"
     :tableTitle         "Metrische Gewinde"
     :logicalTable       "M-Gew-Tab"
     :columns            '(:GEW_NAME :NENN_D :KERN_D :STEIGUNG :GEW_ART :GEW_INNEN :METR :RECHTS_GEW)
     :applyColumns       '(:GEW_ART :GEW_NAME :NENN_D :KERN_D :STEIGUNG :GEW_INNEN :METR :RECHTS_GEW)
     :displayHeight      180
     :filterStatusLine   nil
     :selectionMode      :single-row
     :applyAction        :default-tokens
);;sd-create-display-table



(sd-defdialog 'gdm-m1-gewinde-dialog
 :dialog-title (sd-multi-lang-string "Define Thread" :german "Gewinde definieren")
 :toolbox-button t
 :variables
 '(
   (T-FEEDBACKS :initial-value nil) ;; all feedbacks shown
   (RESULT      :initial-value nil) ;; saved return value of sd-*-thread functions
   (PROPS       :initial-value nil) ;; cylinder face properties
   (ACHSE       :initial-value nil)
   (CENTER      :initial-value nil)

   (FLAECHE
     :selection *sd-cylinder-seltype*
     :title (sd-multi-lang-string "Cyl. Face" :german "Zyl. Flaeche")
     :after-input
      (let (START RADIUS)
        (dolist (a-fb T-FEEDBACKS) (sd-end-point-feedback a-fb)) ;; remove old feedback
        (setf PROPS  (sd-inq-geo-props FLAECHE :dest-space :global))
        (setf CENTER (sd-cylinder-center    PROPS))  ;; really the center , also in ACHSE direction!
        (setf ACHSE  (sd-cylinder-axis-dir  PROPS))
        (setf START  (sd-cylinder-start-dir PROPS))  ;; this is for rotaion,
        (setf RADIUS (sd-cylinder-radius    PROPS))
        (setf ZYL_D  (* 2 radius))
        (push (sd-start-direction-feedback :point CENTER :direction ACHSE :disc t :color 0,0,1) T-FEEDBACKS)
        (sd-set-variable-status 'T-DEFINE  :enable t)
        (sd-set-variable-status 'T-INQ     :enable t)
        (sd-set-variable-status 'T-DESTROY :enable t)
        (sd-set-variable-status 'A-DIR-REVERSE :enable t)
      );;let
   );;FLAECHE

  (ZYL_D
    :title (sd-multi-lang-string "Cylinder D." :german "Zylinder D.")
    :value-type :display-only
    :display-units :length)

   (GEW_NAME
     :title "Name"
     :value-type :string
     :show-input-tool (sd-show-display-table "M-Gew-Tab" :position '("TOP-MENU-TOOLBOX-TB" :lefttop 450 50))
     :hide-input-tool (sd-hide-display-table "M-Gew-Tab" :ignorePin t)
     :initial-value "")

   (METR
     :value-type :boolean
     :initial-value t
     :toggle-type :grouped-toggle
     :after-input
      (progn
       (sd-set-variable-status 'NENN_D        :enable t)
       (sd-set-variable-status 'STEIGUNG      :enable t)
       (sd-set-variable-status 'NENN_D_INCH   :enable nil)
       (setf NENN_D_INCH nil)
       (sd-set-variable-status 'STEIGUNG_INCH :enable nil)
       (setf STEIGUNG_INCH nil)
      )
     :title (sd-multi-lang-string "metric" :german "metrisch"))

   (INCH
     :value-type :boolean
     :toggle-type :grouped-toggle
     :after-input
      (progn
       (sd-set-variable-status 'NENN_D        :enable nil)
       (setf NENN_D nil)
       (sd-set-variable-status 'STEIGUNG      :enable nil)
       (setf STEIGUNG nil)
       (sd-set-variable-status 'NENN_D_INCH   :enable t)
       (sd-set-variable-status 'STEIGUNG_INCH :enable t)
      )
     :title "inch")

   (RECHTS_GEW
     :value-type :boolean
     :toggle-type :grouped-toggle
     :initial-value t
     :title (sd-multi-lang-string "Right-Hand" :german "Rechts"))

   (LINKS_GEW
     :value-type :boolean
     :toggle-type :grouped-toggle
     :title (sd-multi-lang-string "Left-Hand" :german "Links"))

   (GEW_INNEN
     :value-type :boolean
     :toggle-type :grouped-toggle
     :initial-value t
     :title (sd-multi-lang-string "Inner-Thread" :german "Innengew."))

   (GEW_AUSSEN
     :value-type :boolean
     :toggle-type :grouped-toggle
     :title (sd-multi-lang-string "Outer-Thread" :german "Außengew."))

   (GEW_ART
     :title (sd-multi-lang-string "Thread Type" :german "Gewindeart")
     :after-input
      (if (or (eq GEW_ART :M) (eq GEW_ART :MF) (eq GEW_ART :TR) (eq GEW_ART :S))
            (progn
               (sd-set-variable-status 'NENN_D        :enable t)
               (sd-set-variable-status 'STEIGUNG      :enable t)
               (sd-set-variable-status 'NENN_D_INCH   :enable nil)
               (setf NENN_D_INCH nil)
               (sd-set-variable-status 'STEIGUNG_INCH :enable nil)
               (setf STEIGUNG_INCH nil)
               (setf METR t INCH nil)
            );;progn
           (progn
              (sd-set-variable-status 'NENN_D        :enable nil)
              (setf NENN_D nil)
              (sd-set-variable-status 'STEIGUNG      :enable nil)
              (setf STEIGUNG nil)
              (sd-set-variable-status 'NENN_D_INCH   :enable t)
              (sd-set-variable-status 'STEIGUNG_INCH :enable t)
              (setf INCH t METR nil)
           );;progn
      );;if
     :range (:M :MF :BSW :BSF :BSP :UNC :UNF :NPT :TR :S :R :E))

   (NENN_D
     :title (sd-multi-lang-string "Nominal-D." :german "Nenn-D.")
     :value-type :positive-length)

   (STEIGUNG
     :title (sd-multi-lang-string "Pitch" :german "Steigung")
     :value-type :positive-length)

   (NENN_D_INCH
     :initial-enable nil
     :title (sd-multi-lang-string "Nominal-D. INCH" :german "Nenn-D. INCH")
     :value-type :string
     :proposals '("#12" "1/4" "3/8" "1" "1 1/2"))

   (STEIGUNG_INCH
     :initial-enable nil
     :title (sd-multi-lang-string "Pitch INCH" :german "Steigung INCH")
     :value-type :positive-integer
     :proposals '("14" "18" "20" "24" "28"))

   (KERN_D
     :title (sd-multi-lang-string "Core-D." :german "Kern-D.")
     :value-type :positive-length)

   (FASE
     :title (sd-multi-lang-string "Include existing chamfer" :german "vorh. Fase einbeziehen")
     :value-type :boolean
     :toggle-type :wide-toggle
     :initial-value T)

   (A-DIR-REVERSE
     :title (sd-multi-lang-string "Reverse" :german "Umkehren")
     :value-type :grouped-boolean
     :after-input
      (progn
       (dolist (a-fb T-FEEDBACKS) (sd-end-point-feedback a-fb))
       (setf ACHSE (make-gpnt3d :x (* -1 (gpnt3d_x ACHSE)) :y (* -1 (gpnt3d_y ACHSE)) :z (* -1 (gpnt3d_z ACHSE))))
       (push (sd-start-direction-feedback :point CENTER :direction ACHSE :disc t  :color 0,0,1) T-FEEDBACKS)
      );;progn
     :initial-enable nil)

   (RESET
     :title "Reset"
     :toggle-type :grouped-toggle
     :push-action
      (setf GEW_NAME nil METR t INCH nil RECHTS_GEW t LINKS_GEW nil GEW_INNEN t GEW_AUSSEN nil
            NENN_D nil NENN_D_INCH nil STEIGUNG nil STEIGUNG_INCH nil KERN_D nil GEW_ART :M  FASE t A-DIR-REVERSE nil))

   ("")
   (T-DEFINE
     :initial-enable NIL
     :toggle-type :wide-toggle
     :title (sd-multi-lang-string "Attach Thread Attributes" :german "Gewindeattribute setzen")
     :next-variable 'FLAECHE
     :push-action (Gewinde-erstellen-check))

   ("")
   (T-INQ
     :initial-enable nil
     :toggle-type :wide-toggle
     :title (sd-multi-lang-string "Read Thread Attributes" :german "Gewindeattribute lesen")
     :next-variable 'FLAECHE
     :push-action (Gewinde-abfragen))

   ("")
   (T-DESTROY
     :initial-enable NIL
     :toggle-type :wide-toggle
     :title (sd-multi-lang-string "Delete Thread Attributes" :german "Gewindeattribute loeschen")
     :next-variable 'FLAECHE
     :push-action (Gewinde-loeschen))

 );;variables

 :mutual-exclusion '((METR INCH) (RECHTS_GEW LINKS_GEW) (GEW_INNEN GEW_AUSSEN))

 :local-functions
 '(
   (Gewinde-erstellen-check ()
    (if METR
     (if GEW_INNEN
      (if (= KERN_D ZYL_D)
       (Gewinde-erstellen)
       (sd-display-error (format nil "Der Kerndurchmesser ~a entspricht nicht dem gewaehlten Zylinderdurchmesser ~a! Es wurde kein Gewinde erstellt!" (sd-num-to-string KERN_D) (sd-num-to-string ZYL_D)))
      );;if
      (if (= NENN_D ZYL_D)
       (Gewinde-erstellen)
       (sd-display-error (format nil "Der Nenndurchmesser ~a entspricht nicht dem gewaehlten Zylinderdurchmesser ~a! Es wurde kein Gewinde erstellt!" (sd-num-to-string NENN_D) (sd-num-to-string ZYL_D)))
      );;if
     );;if
    );;if
   );;Gewinde-erstellen-check

   (Gewinde-erstellen ()
      (sd-define-thread FLAECHE
          :nominal-diameter       (if METR NENN_D)
          :nominal-diameter-inch  (if INCH NENN_D_INCH)
          :core-diameter          KERN_D
          :pitch                  (if METR STEIGUNG)
          :tpi                    (if INCH STEIGUNG_INCH)
          :thread-type            (if GEW_INNEN :INNER :OUTER)
          :thread-unit            (if METR :metric :inch)
          :thread-color           (sd-color-to-rgb 16753049)
          :thread-hand            (if RECHTS_GEW :right-hand :left-hand)
          :thread-profile         GEW_ART
          :include-chamfer        FASE
          :thread-direction       (if A-DIR-REVERSE :REVERSE-CYL-AXIS :CYL-AXIS)
          :thread-name            GEW_NAME
      );;sd-define-thread
     (dolist (a-fb T-FEEDBACKS) (sd-end-point-feedback a-fb))
     (setf FLAECHE nil)
  );;Gewinde-erstellen

  (Gewinde-abfragen ()
    (setf RESULT (oli::sd-inq-thread FLAECHE))
    (if RESULT
      (progn
        (sd-display-message (format nil "thread detected~%~%~{:~A ~A~%~}" (nthcdr 2 RESULT)))

        (if (getf RESULT :nominal-diameter-inch)
            (progn
              (sd-set-variable-status 'NENN_D_INCH :enable t)
              (sd-set-variable-status 'NENN_D      :enable nil)
              (setf NENN_D_INCH (getf RESULT :nominal-diameter-inch) NENN_D nil)
            );;progn
            (progn
              (sd-set-variable-status 'NENN_D      :enable t)
              (sd-set-variable-status 'NENN_D_INCH :enable nil)
              (setf NENN_D (getf RESULT :nominal-diameter) NENN_D_INCH nil)
            );;progn
        );;if
        (setf KERN_D (getf RESULT :core-diameter))
        (if (getf RESULT :TPI)
            (progn
              (sd-set-variable-status 'STEIGUNG_INCH :enable t)
              (sd-set-variable-status 'STEIGUNG      :enable nil)
              (setf STEIGUNG_INCH (getf RESULT :tpi) STEIGUNG nil)
            );;progn
            (progn
              (sd-set-variable-status 'STEIGUNG      :enable t)
              (sd-set-variable-status 'STEIGUNG_INCH :enable nil)
              (setf STEIGUNG (getf RESULT :pitch) STEIGUNG_INCH nil)
            );;progn
        );;if

        (if (eq (getf RESULT :thread-type) :inner) ;; :inner :outer
            (setf GEW_INNEN t GEW_AUSSEN nil)
            (setf GEW_AUSSEN t GEW_INNEN nil)
        );;if

        (if (eq (getf RESULT :thread-unit) :metric) ;; :metric :inch
            (setf METR t INCH nil)
            (setf INCH t METR nil)
        );;if

        (if (eq (getf RESULT :thread-hand) :right-hand) ;; :right-hand :left-hand
            (setf RECHTS_GEW t LINKS_GEW nil)
            (setf LINKS_GEW t RECHTS_GEW nil)
        );;if

        (setf GEW_ART (getf RESULT :thread-profile))   ;; :M :MF usw.
        (setf FASE    (getf RESULT :include-chamfer))
        (setf A-DIR-REVERSE (NOT (sd-vec-equal-p (getf RESULT :thread-direction) (sd-cylinder-axis-dir PROPS))))
        (setf GEW_NAME (getf RESULT :thread-name))
      );;progn
      (sd-display-message "Keine sd-define-thread Informationen verfuegbar")
    );;if
  );;Gewinde-abfragen

  (Gewinde-loeschen ()
    (setf RESULT (oli::sd-destroy-thread FLAECHE))
    (if RESULT
        (sd-display-message "Gewinde entfernt")
        (sd-display-message "Keine Gewindeinformation verfuegbar oder Gewinde nicht entfernt")
    );;if
    (dolist (a-fb T-FEEDBACKS) (sd-end-point-feedback a-fb))
    (setf FLAECHE nil)
  );;Gewinde-loeschen

 );;local-functions

 :cleanup-action
 '(progn
    (dolist (a-fb T-FEEDBACKS) (sd-end-point-feedback a-fb)) ;; remove old feedback
  );;progn

; :help-action '(sd-display-url (format nil "file:~a/LISP/gdm_m1_gewinde.mht" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
 :help-action '(sd-display-url "C:/ ... PFAD ANPASSEN ... /gdm_m1_gewinde.mht")

);;sd-defdialog
